﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Http.Headers;
using System.IO;
using System.Net.Http.Formatting;
using System.Threading.Tasks;
using HotelService.Data;

namespace HotelService.Formatter
{
    // RC: Methodensignaturen haben sich geändert. Implementierung scheint nach wie vor zu funktionieren ...
    public class FlatFileFormatter : BufferedMediaTypeFormatter
    {
        public FlatFileFormatter()
        {
            this.SupportedMediaTypes.Add(new MediaTypeHeaderValue("text/csv"));
        }

        public override bool CanReadType(Type type)
        {
            return typeof(IEnumerable<Hotel>).IsAssignableFrom(type);
        }

        public override bool CanWriteType(Type type)
        {
            return typeof(IEnumerable<Hotel>).IsAssignableFrom(type);
        }

        /*
        protected override bool CanReadType(Type type)
        {
            
            
        }

        protected override bool CanWriteType(Type type)
        {
            
        }
        */
        public override object ReadFromStream(Type type, Stream readStream, System.Net.Http.HttpContent content, IFormatterLogger formatterLogger)
        {
            
        
            var hotels = new List<Hotel>();
            StreamReader r = new StreamReader(readStream);

            string line;
            while ((line = r.ReadLine()) != null)
            {
                if (line.Trim() == "") continue;
                var cols = line.Split(',');
                var hotel = new Hotel
                {
                    HotelId = Convert.ToInt32(cols[0]),
                    Bezeichnung = cols[1],
                    Sterne = Convert.ToInt32(cols[2])
                };
                hotels.Add(hotel);
            }

            return hotels;
        }

        public override void WriteToStream(Type type, object value, Stream writeStream, System.Net.Http.HttpContent content)
        {
            
            var hotels = (IEnumerable<Hotel>)value;
            if (hotels == null) return;

            StreamWriter w = new StreamWriter(writeStream);
            foreach (Hotel h in hotels)
            {
                w.WriteLine(h.HotelId + "," + h.Bezeichnung + "," + h.Sterne);
            }
            w.Flush();

        }

        /*
        protected override void OnWriteToStream(Type type, object value, Stream stream, HttpContentHeaders contentHeaders, FormatterContext formatterContext, System.Net.TransportContext transportContext)
        {
        }
        */
        /*
        protected override object OnReadFromStream(Type type, Stream stream, HttpContentHeaders contentHeaders, FormatterContext formatterContext)
        {
        }
         */
    }

}
