﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Http.SelfHost;
using System.Web.Http;
using System.Security.Cryptography.X509Certificates;
using System.ServiceModel.Channels;
using System.Web.Http.SelfHost.Channels;
using HotelService.Controllers;
using System.Security;
using HotelService.Security;
using System.Web.Http.Description;
using WebAPI_RC1.Controllers;


namespace SelfHosting
{
    /*
     * Benötigte Referenzen:
        System.Net.Http
        System.Web.Extensions
        System.Web.Http
        System.Web.Http.Common
        System.Web.Http.SelfHost
      */

    //    http://pfelix.wordpress.com/2012/02/26/enabling-https-with-self-hosted-asp-net-web-api/


    //RC: Wird nicht mehr benötigt. SSL wird nun direkt von HttpSelfHostConfiguration unterstützt!
    /*
    class MyHttpsSelfHostConfiguration : HttpSelfHostConfiguration
    {
        public MyHttpsSelfHostConfiguration(string baseAddress) : base(baseAddress) { }
        public MyHttpsSelfHostConfiguration(Uri baseAddress) : base(baseAddress) { }
        protected override BindingParameterCollection OnConfigureBinding(HttpBinding httpBinding)
        {
            httpBinding.Security = new HttpBindingSecurity()
            {
                Mode = HttpBindingSecurityMode.Transport,
            };

            

            return base.OnConfigureBinding(httpBinding);
        }
    }
    */

    class Program
    {




        static X509Certificate2 FindCertificate(
            StoreLocation location, StoreName name,
            X509FindType findType, string findValue)
        {
            X509Store store = new X509Store(name, location);
            try
            {
                // create and open store for read-only access
                store.Open(OpenFlags.ReadOnly);

                // search store
                X509Certificate2Collection col = store.Certificates.Find(
                  findType, findValue, true);

                // return first certificate found
                return col[0];
            }
            // always close the store
            finally { store.Close(); }
        }



        static void Main(string[] args)
        {
        var config = new HttpSelfHostConfiguration("http://localhost:8080");
        //var config = new HttpSelfHostConfiguration("https://localhost:44399");

        // Authorization: Basic bWF4OmdlaGVpbQ==

          


        // HACK für MVC 4 BETA, Controller in Speicher laden ...
        // RC: Wird nicht mehr benötigt 
        // Type hc = typeof(HotelsController);
        // Type bc = typeof(BuchungenController);


        Type bc = typeof(BilderController);

        config.Routes.MapHttpRoute(
            "API Default", "api/{controller}/{id}",
            new { id = RouteParameter.Optional });

        //config.ServiceCertificate.SetCertificate(StoreLocation.LocalMachine, StoreName.My, X509FindType.FindByThumbprint, "24e2f9c13090f52f378ffcd40172787daa0d930a");


        // netsh http add urlacl url=http://+:8080/ user=machine\username
        // netsh http add sslcert ipport=0.0.0.0:4443 certhash=24e2f9c13090f52f378ffcd40172787daa0d930a appid={00000000-0000-0000-0000-000000000000}
        config.IncludeErrorDetailPolicy = IncludeErrorDetailPolicy.Always;
        //config.TransferMode = System.ServiceModel.TransferMode.Buffered; // Streamed, StreamedRequest, StreamedResponse
        config.TransferMode = System.ServiceModel.TransferMode.Streamed; 
        config.MaxReceivedMessageSize = 1000000000;
        config.MaxBufferSize = 1024*100;
        config.SendTimeout = TimeSpan.FromMinutes(5);
            
        config.MaxConcurrentRequests = 20;
            
        //config.UserNamePasswordValidator = new CustomUserNamePasswortValidator();


        //ShowOperations(config);

        using (HttpSelfHostServer server = new HttpSelfHostServer(config))
        {
            server.OpenAsync().Wait();
            Console.WriteLine("Press Enter to quit.");
            Console.ReadLine();
        }

        }

        private static void ShowOperations(HttpSelfHostConfiguration config)
        {
            IApiExplorer explorer = config.Services.GetApiExplorer();

            // Alternative
            // IApiExplorer explorer = GlobalConfiguration.Configuration.Services.GetApiExplorer();

            foreach (ApiDescription desc in explorer.ApiDescriptions)
            {
                Console.WriteLine(desc.HttpMethod);
                Console.WriteLine(desc.RelativePath);

                foreach (ApiParameterDescription param in desc.ParameterDescriptions)
                {
                    Console.WriteLine("\t" + param.Name + " " + param.Source.ToString() + " ");
                }
            }
        }


    }
}
