﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Http.Dispatcher;
using System.Web.Mvc;
using System.Web.Routing;
using WebAPI_RC1.Handler;

namespace WebAPI_RC1
{
    public class RouteConfig
    {
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");


            var handler = new LimitResultMessageHandler()
            {
                InnerHandler = new HttpControllerDispatcher(GlobalConfiguration.Configuration)
            };



            routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );

            routes.MapHttpRoute(
    name: "BuchungenByHotelRoute",
    routeTemplate: "api/Hotels/{hotelId}/Buchungen",
    defaults: new { controller = "Buchungen" },
    constraints: null, // Notwendig, damit richtige Überladung gewählt wird!
    handler: handler
);



            routes.MapRoute(
                name: "Default",
                url: "{controller}/{action}/{id}",
                defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional }
            );
        }
    }
}