﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;
using System.Web.Http;

namespace WebAPI_RC1.Controllers
{

    /*
     * Beispiel für Ausgabe in Debug-Fenster:
       
        HotelId: 34
        File: c:\temp\bilder\BodyPart_037fe931-6dc6-48c8-95bc-b8c3e2813e46
           Header: Content-Disposition: form-data; name="data"; filename="ChangeLog.htm"
           Header: Content-Type: text/html
        File: c:\temp\bilder\BodyPart_d4e7b128-dd3b-4d66-aad2-4f3c8f8ca045
           Header: Content-Disposition: form-data; name="data"; filename="Default.htm"
           Header: Content-Type: text/html
        File: c:\temp\bilder\BodyPart_45ebda0a-9d95-4c96-85ea-f8f634415dde
           Header: Content-Disposition: form-data; name="data"; filename="Eula.htm"
           Header: Content-Type: text/html
       
     */

    public class BilderController : ApiController
    {

        public HttpResponseMessage Get()
        {
            var response = new HttpResponseMessage();
            var stream = new FileStream(@"c:\temp\bilder\info.dat", FileMode.Open);
            response.Content = new StreamContent(stream);

            return response;
        }

        public async void Put() // Post oder Put ???
        {
            Stream s = await Request.Content.ReadAsStreamAsync();
            long count = 0;

            byte[] buffer = new byte[100*1024];
            while (s.Read(buffer,0, buffer.Length) > 0)
            {
                count++;
                Debug.WriteLine(count); // Just for displaying progress
            }
        }

        public async Task<string> Post() // Post oder Put
        {
            if (!Request.Content.IsMimeMultipartContent("form-data"))
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }

            // Daneben gibt es noch weitere Provider: 
            // http://blogs.msdn.com/b/henrikn/archive/2012/04/27/asp-net-web-api-updates-april-27.aspx

            var formDataProvider = new MultipartFormDataStreamProvider(@"c:\temp\bilder");
            var bodyParts = await Request.Content.ReadAsMultipartAsync(formDataProvider);
            

            var hotelId = bodyParts.FormData["hotelId"];
            Debug.WriteLine("HotelId: " + hotelId);

            foreach (var file in bodyParts.FileData)
            {
                
                Debug.WriteLine("File: " + file.LocalFileName);
                foreach (var h in file.Headers)
                {
                    var array = h.Value as IEnumerable<string>;
                    if (array != null) {
                        Debug.WriteLine("   Header: " + h.Key + ": " + string.Join("|", array));
                    }
                    else {
                        Debug.WriteLine("   Header: " + h.Key + ": " + h.Value);
                    }
                    
                }
            }

            return bodyParts.FileData.Count + " Dateien für Hotel #" + hotelId + " hochgeladen!";

        }



    }
}
