﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.ServiceModel.Channels;
using System.Web.Http;

namespace WebAPI_RC1.Controllers
{
    public class HotelStateController : ApiController
    {

        private static ConcurrentQueue<StreamWriter> clients = new ConcurrentQueue<StreamWriter>();
        private static Dictionary<int, int> hotelState = new Dictionary<int, int>();


        static HotelStateController()
        {
            hotelState[1] = 100;
            hotelState[2] = 100;
            hotelState[3] = 100;
            hotelState[4] = 100;
        }

        public HttpResponseMessage Get(HttpRequestMessage request)
        {
            HttpResponseMessage response = request.CreateResponse();
            response.Content = new PushStreamContent(OnStreamAvailable, "text/event-stream");
            return response;
        }

        public int Post(int hotelId)
        {
            int anzahl;
            lock (clients)
            {

                if (!hotelState.ContainsKey(hotelId)) throw new HttpResponseException(HttpStatusCode.BadRequest);

                

                anzahl = hotelState[hotelId];

                if (anzahl == 0) throw new HttpResponseException(HttpStatusCode.BadRequest);
                anzahl--;
                hotelState[hotelId] = anzahl;
            }


            foreach (var client in clients)
            {
                client.WriteLine(@"data: Hotel:" + hotelId + ", Anzahl: " + anzahl + "\n");
                client.Flush();
            }

            return anzahl;

        }

        public static void OnStreamAvailable(Stream stream, HttpContent headers, TransportContext context)
        {
            StreamWriter streamwriter = new StreamWriter(stream);
            clients.Enqueue(streamwriter);
        }


    }
}