﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web.Http;
using HotelService.Data;
using System.Net;
using System.IO;
using System.Diagnostics;

namespace HotelService.Controllers
{
    public class HotelsController : ApiController
    {
        // /Hotels/4711
        public Hotel GetHotel(int id)
        {
            var rep = new HotelRepository();
            var hotel = rep.FindById(id);
            
            // RC: HttpResponseException erwartet nun eine HttpResponseMessage
            if (hotel == null)
            {
                var errorResponse = new HttpResponseMessage(HttpStatusCode.NotFound);
                throw new HttpResponseException(errorResponse);
            }

            

            return hotel;
        }

        // Hotels/?minSterne=3
        [HttpGet]
        public List<Hotel> FindHotelsBySterne(int minSterne)
        {
            var rep = new HotelRepository();
            var hotels = rep.FindBySterne(minSterne);
            return hotels;
        }

        // IIS8: Nicht vergessen: Verben in IIS-Config freigeben
        [AcceptVerbs("X-TEST")]
        public byte[] Test()
        {
            return new byte[]{1,2,3,4,5,6,65,66,67,68,69,90};
        }

        // IIS8: Nicht vergessen: Verben in IIS-Config freigeben
        [AcceptVerbs("X-INFO")]
        public string Info()
        {
            return "Hello World!";
        }

        [Queryable()]
        public IQueryable<Hotel> GetHotels()
        {
            var rep = new HotelRepository();
            return rep.FindAll();
        }

        public Hotel PutHotel(int id, Hotel hotel)
        {
            var rep = new HotelRepository();
            hotel.HotelId = id;
            rep.CreateOrUpdate(hotel);
            return hotel;
        }

        public Hotel PostHotel(Hotel hotel)
        {
            var rep = new HotelRepository();
            rep.Create(hotel);
            return hotel;
        }

        // IIS8: Nicht vergessen: Verben in IIS-Config freigeben
        [AcceptVerbs("X-ECHO")]
        public List<Hotel> EchoHotels(List<Hotel> hotels)
        {
            return hotels;
        }



        public void DeleteHotel(int id)
        {
            var rep = new HotelRepository();
            rep.Delete(id);
        }

        // IIS8: Nicht vergessen: Verben in IIS-Config freigeben
        [AcceptVerbs("X-PING")]
        public string Echo(String message)
        {
            return "Got: " + message;
        }

        // RC: JsonValue scheint nicht mehr zu existieren ...
        /*
        [AcceptVerbs("X-INFO")]
        [ActionName("ImplementationInfo")]
        public JsonValue GetImplementationInfo(JsonValue value)
        {
            
            Debug.WriteLine(value.ContainsKey("Version"));

            dynamic request = value.AsDynamic();

            Debug.WriteLine(request.GetType().Name);

            dynamic response = new JsonObject();
            
            response.Version = 0.9;

            if (request.All.ReadAs<bool>() == true )
            {
                response.Autor = "Manfred Steyer";
                response.URL = "www.softwarearchitekt.at";
            }

            return response;
        }
       */

    }
}
