﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.Controllers;
using System.Web.Http.Tracing;

namespace WebAPI_RC1.Controllers
{

    public class CustomConfig : Attribute, IControllerConfiguration, ITraceWriter
    {
        public void Initialize(HttpControllerSettings controllerSettings, HttpControllerDescriptor controllerDescriptor)
        {
            controllerSettings.Formatters.RemoveAt(0);
            controllerSettings.Services.Replace(typeof(ITraceWriter), this);
        }

        public void Trace(HttpRequestMessage request, string category, System.Web.Http.Tracing.TraceLevel level, Action<TraceRecord> traceAction)
        {
            TraceRecord record = new TraceRecord(request, category, level);
            traceAction(record);
            Debug.WriteLine(category + ": " + level + " " + record.Message);
        }
    }

    [CustomConfig]
    public class MiniBarController : ApiController
    {

        public double GetPrice(int hotelId, int roomNumber)
        {
            return 42;
        }

    }
}
