﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace HotelService.Data
{
    public class HotelBuchungRepository
    {
        private static List<HotelBuchung> Buchungen { get; set; }

        static HotelBuchungRepository()
        {
            Buchungen = new List<HotelBuchung>();

            Buchungen.Add(
                new HotelBuchung { 
                    HotelBuchungId = 1, 
                    HotelId = 2, 
                    Vorname = "Max", 
                    Nachname = "Muster" });

            Buchungen.Add(
                new HotelBuchung
                {
                    HotelBuchungId = 2,
                    HotelId = 2,
                    Vorname = "Susi",
                    Nachname = "Sorglos"
                });

            Buchungen.Add(
                new HotelBuchung
                {
                    HotelBuchungId = 3,
                    HotelId = 2,
                    Vorname = "Marta",
                    Nachname = "Pfahl"
                });

            Buchungen.Add(
                new HotelBuchung
                {
                    HotelBuchungId = 4,
                    HotelId = 2,
                    Vorname = "Reiner",
                    Nachname = "Zufall"
                });

        }


        public List<HotelBuchung> FindAll()
        {
            return Buchungen;
        }

        public List<HotelBuchung> FindByHotel(int hotelId)
        {
            var buchungen = Buchungen
                            .Where(b => b.HotelId == hotelId)
                            .ToList();
            
            return buchungen;
        }

        public void Create(HotelBuchung buchung)
        {
            buchung.HotelBuchungId = Buchungen.Max(b => b.HotelBuchungId) + 1;
            Buchungen.Add(buchung);
        }

        public void CreateOrUpdate(HotelBuchung buchung)
        {
            Delete(buchung.HotelBuchungId.Value);
            Buchungen.Add(buchung);
        }

        public void Delete(int hotelBuchungId)
        {
            var b = FindById(hotelBuchungId);
            Buchungen.Remove(b);
        }

        public HotelBuchung FindById(int hotelBuchungId)
        {
            return Buchungen.FirstOrDefault(b => b.HotelBuchungId == hotelBuchungId);
        }

    }
}