﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace HotelService.Data
{
    public class HotelRepository
    {
        private static List<Hotel> Hotels { get; set; }


        static HotelRepository()
        {
            Hotels = new List<Hotel>();

            Hotels.Add(
                new Hotel { 
                    HotelId = 1, 
                    Bezeichnung = "Hotel zur Post", 
                    Sterne = 3 });

            Hotels.Add(
                new Hotel { 
                    HotelId = 2, 
                    Bezeichnung = "Wellneshotel Costalot", 
                    Sterne = 4 });

            Hotels.Add(
                new Hotel { 
                    HotelId = 3, 
                    Bezeichnung = "Hotel BizPark", 
                    Sterne = 4 });




        }


        public List<Hotel> FindBySterne(int minSterne)
        {
            var hotels =
                    Hotels
                        .Where(h => h.Sterne >= minSterne)
                        .ToList();
            return hotels;
        }

        public IQueryable<Hotel> FindAll()
        {
            return Hotels.ToList().AsQueryable();
        }

        public void CreateOrUpdate(Hotel hotel)
        {
            var hotel2update = this.FindById(hotel.HotelId.Value);

            if (hotel2update == null)
            {
                Hotels.Add(hotel);
            }
            else
            {
                hotel2update.Bezeichnung = hotel.Bezeichnung;
                hotel2update.Sterne = hotel.Sterne;
            }
        }

        public void Create(Hotel hotel)
        {
            hotel.HotelId = Hotels.Max(h => h.HotelId) + 1;
            Hotels.Add(hotel);
        }

        public void Delete(int id)
        {
            var hotel2delete = Hotels.FirstOrDefault(h => h.HotelId == id);
            if (hotel2delete != null) Hotels.Remove(hotel2delete);
        }




        public Hotel FindById(int id)
        {
            var hotel =
                    Hotels
                        .Where(h => h.HotelId == id)
                        .FirstOrDefault();

            return hotel;
        }

        

    }
}