﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web;

namespace WebAPI_RC1.Handler
{
    public class LimitResultMessageHandler : DelegatingHandler
    {

        protected override async System.Threading.Tasks.Task<HttpResponseMessage> SendAsync(HttpRequestMessage request, System.Threading.CancellationToken cancellationToken)
        {
            var response = await base.SendAsync(request, cancellationToken);

            var objectContent = response.Content as ObjectContent;
            if (objectContent == null) return response;

            var collection = objectContent.Value as IEnumerable<object>;
            if (collection == null) return response;

            if (collection.Count() > 3)
            {
                return request.CreateResponse(
                                response.StatusCode, 
                                collection.Take(3), 
                                objectContent.Formatter);
            }

            return response;
        }
    }
}