﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.AspNet.SignalR.Client;


namespace PersistentConnectionClient
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("[Enter]");
            Console.ReadLine();

        
            // var connection = new Connection("http://localhost:8081/simple");
            var connection = new Connection("http://localhost:15923/simple");

            connection.Received += data =>
            {
                Console.WriteLine("Empfangen: " + data);
            };

            connection.Error += ex =>
            {
                Console.WriteLine("Fehler: " + ex.Message);
            };



            connection.Start().ContinueWith(task =>
            {
                if (task.IsFaulted)
                {
                    Console.WriteLine("Fehler: " + task.Exception.Message);
                }
                else
                {
                    Console.WriteLine("Verbindung aufgebaut!");
                }
            });

            string line;
            while ((line = Console.ReadLine()) != "exit")
            {
                connection.Send(line).ContinueWith(task =>
                {
                    if (task.IsFaulted)
                    {
                        Console.WriteLine("Fehler: " + task.Exception.Message);
                    }
                    else
                    {
                        Console.WriteLine("Gesendet");
                    }
                });
            }

            


        }
    }
}
