﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using SignalRDemo.Hubs;
using Microsoft.AspNet.SignalR;

namespace SignalRDemo.Controllers
{

    public class FlightBooking
    {
        public int FlugId { get; set; }
        public string Vorname { get; set; }
        public string Nachname { get; set; }
    }

    public class FlugController : ApiController
    {

        public string PostFlightBooking(FlightBooking booking)
        {
            var context = GlobalHost.ConnectionManager.GetHubContext<MulticastFlugHub>();
            var ticketId = Guid.NewGuid().ToString();

            context.Clients.Group("flug" + booking.FlugId).FlightUpdated(booking.FlugId, ticketId, 42);
            return ticketId;
        }
    }
}
