﻿using Microsoft.AspNet.SignalR.Hubs;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.AspNet.SignalR;

namespace SignalRDemo.Hubs
{
    public class FlugException : Exception
    {
        public FlugException(string msg) : base(msg) { }
        public int FlugId { get; set; }
    }

    public class FlugHub: Hub
    {
        // FlugId --> Anzahl freier Plätze
        private static Dictionary<int, int> freePerFlight = new Dictionary<int, int>();
        private int nextTicket = 1;

        static FlugHub()
        {
            freePerFlight[4711] = 100;
            freePerFlight[4712] = 100;
            freePerFlight[4713] = 100;
        }

        public string BookFlight(int flugId, string vorname, string nachname)
        {
            int free;
            string ticketId;
            lock (freePerFlight)
            {
                if (!freePerFlight.ContainsKey(flugId)) throw new Exception("Flug " + flugId + " existiert nicht!");
                free = freePerFlight[flugId];
                free--;
                freePerFlight[flugId] = free;
                ticketId = "T" + nextTicket;
                nextTicket++;
            }

            

            this.Clients.Caller.BookFlightCompleted(flugId, ticketId, vorname, nachname);
            this.Clients.All.FlightUpdated(flugId, ticketId, free);
            return ticketId;
        }

        

    }
}