﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;
using Microsoft.AspNet.SignalR;
using Server.Modules;
using SignalRDemo.PersistentConnections;

namespace SignalRDemo
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            // Register the default hubs route: ~/signalr/hubs
            RouteTable.Routes.MapHubs();

            //var config = new HubConfiguration();
            //config.EnableDetailedErrors = true;
            //RouteTable.Routes.MapHubs(config);

            GlobalHost.HubPipeline.AddModule(new LoggingPipelineModule());
            
            // GlobalHost.Configuration.ConnectionTimeout

            // BREAKING CHANGE
            RouteTable.Routes.MapConnection<SimplePersistentConnection>("simple", "/simple");

            AreaRegistration.RegisterAllAreas();

            WebApiConfig.Register(GlobalConfiguration.Configuration);
            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            BundleConfig.RegisterBundles(BundleTable.Bundles);
            AuthConfig.RegisterAuth();
        }
    }
}