﻿using Microsoft.AspNet.SignalR.Hubs;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Security.Principal;
using System.Web;

namespace Server.Modules
{

    public class LoggingPipelineModule : HubPipelineModule
    {

        

        protected override bool OnBeforeAuthorizeConnect(HubDescriptor hubDescriptor, Microsoft.AspNet.SignalR.IRequest request)
        {
            return base.OnBeforeAuthorizeConnect(hubDescriptor, request);
        }

        protected override bool OnBeforeIncoming(IHubIncomingInvokerContext context)
        {
            Debug.WriteLine("[{0}] OnBeforeIncoming: Method {1} on Hub {2}", DateTime.Now, context.MethodDescriptor.Name, context.MethodDescriptor.Hub.Name );
            
            return base.OnBeforeIncoming(context);
        }

        protected override bool OnBeforeOutgoing(IHubOutgoingInvokerContext context)
        {
            Debug.WriteLine("[{0}] OnBeforeOutgoing: Method {1} on Hub {2}", DateTime.Now, context.Invocation.Method, context.Invocation.Hub);
            return base.OnBeforeOutgoing(context);
            
        }
    }
}