﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using HotelBuchungen.Data;
using HotelBuchungen.Models;

namespace HotelBuchungen
{
    public class HotelController : Controller
    {
        //
        // GET: /Hotel/

        public ActionResult Index()
        {
            var rep = new HotelRepository();

            var hotels = rep.FindAll();
            // Optional: In ViewModels umwandeln ...

            return View(hotels);
        }

        public ActionResult Edit(int hotelId)
        {
            var rep = new HotelRepository();
            var hotel = rep.FindById(hotelId);
            return View(hotel);
        }

        [HttpPost]
        public ActionResult Edit(Hotel hotel)
        {
            var states = new Dictionary<HotelBuchung, State>();

            foreach (var b in hotel.HotelBuchung)
            {
                b.HotelId = hotel.HotelId;
                if (b.Deleted) states[b] = State.Deleted;
                if (b.Modified) states[b] = State.Modified;
                if (b.Added && !string.IsNullOrEmpty(b.Vorname) ) states[b] = State.Added;

                
            }

            var rep = new HotelRepository();
            rep.Save(hotel, states);
            var hotel2 = rep.FindById(hotel.HotelId);
            return View(hotel2);

        }

        protected override void Dispose(bool disposing)
        {
            base.Dispose(disposing);
        }

    }
}
