﻿using System;
using System.Collections.Generic;
using System.Data.Services.Client;
using System.Data.Services.Common;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.Data.OData;
using ODataClient.Proxy;

namespace ODataClient
{
    
    

    class Program
    {


        static void Main(string[] args)
        {
            // WICHTIG: WCF Data Services 5.2 RTM Tools installieren:
            //  http://www.microsoft.com/en-us/download/details.aspx?id=35840

            

            Console.WriteLine("Start: [ENTER]");
            Console.ReadLine();

            var uri = new Uri("http://localhost:1701/odata");
            var ctx = new Container(uri);

            var hotelList = ctx.Hotels.ToList();

            var hotel = new Hotel
            {
                Bezeichnung = "Hotel Test",
                Sterne = 5
            };

            ctx.AddToHotels(hotel);
            ctx.SaveChanges();

            var hb1 = new HotelBuchung();
            hb1.Vorname = "Max";
            hb1.Nachname = "Muster";
            hb1.AnzahlTage = 1;
            hb1.Datum = DateTime.Now;
            hotel.HotelBuchungen.Add(hb1);
            


            ctx.AddToHotelBuchungen(hb1);
            ctx.SaveChanges();

            ctx.AddLink(hotel, "HotelBuchungen", hb1);
            ctx.SaveChanges();

            Region r = new Region();
            r.Bezeichnung = "Graz";

            ctx.AddToRegionen(r);
            ctx.SaveChanges();


            Region r2 = new Region();
            r2.Bezeichnung = "Gleisdorf";

            ctx.AddToRegionen(r2);
            ctx.SaveChanges();


            ctx.SetLink(hotel, "Region", r);
            ctx.SaveChanges();


            ctx.SetLink(hotel, "Region", r2);
            ctx.SaveChanges();

            ctx.DeleteLink(hotel, "HotelBuchungen", hb1);
            ctx.SetLink(hotel, "Region", null);
            ctx.SaveChanges();

            hotel.Sterne++;
            ctx.UpdateObject(hotel);
            ctx.SaveChanges(SaveChangesOptions.ReplaceOnUpdate);

            hotel.Sterne++;
            ctx.UpdateObject(hotel);
            ctx.SaveChanges(SaveChangesOptions.PatchOnUpdate);





            var hotels = ctx.Hotels.Where(h => h.Sterne >= 3).ToList();

            foreach (var h in hotels)
            {
                Console.WriteLine(h.Bezeichnung);
            }

            var buchungen = ctx.Hotels.Where(h => h.HotelId == 1).SelectMany(h => h.HotelBuchungen).ToList();
            foreach (var hb in buchungen)
            {
                Console.WriteLine(hb.Vorname + " " + hb.Nachname);
            }

            //ctx.DeleteObject(hotel);
            //ctx.SaveChanges();




            Console.WriteLine("fertig!");
            Console.ReadLine();


        }
    }
}
