﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.Http.OData.Builder;
using System.Web.Http.OData.Formatter;
using Newtonsoft.Json;
using ODataSample.Controllers;
using ODataSample.Models;

namespace ODataSample
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {
            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );


            config.Formatters.JsonFormatter.SerializerSettings.ReferenceLoopHandling = ReferenceLoopHandling.Ignore;

            // config.EnableQuerySupport();
            config.EnableQuerySupport(new CustomQueryableAttribute());

            var model = CreateModel();
            config.Routes.MapODataRoute("ODataRoute", "odata", model);

        }

        private static Microsoft.Data.Edm.IEdmModel CreateModel()
        {
            ODataModelBuilder modelBuilder = new ODataConventionModelBuilder();
            modelBuilder.EntitySet<Hotel>("Hotels");
            modelBuilder.EntitySet<HotelBuchung>("HotelBuchungen");
            modelBuilder.EntitySet<Region>("Regionen");
            var model = modelBuilder.GetEdmModel();
            return model;
        }

    }
}
