﻿using Microsoft.Data.OData;
using Microsoft.Data.OData.Query;
using ODataSample.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web;
using System.Web.Http;
using System.Web.Http.OData;
using System.Web.Http.OData.Routing;
using System.Web.Mvc;

namespace ODataSample.Controllers
{
    public class HotelBuchungenController : EntitySetController<HotelBuchung, int>
    {
        private HotelDbContext ctx = new HotelDbContext();


        protected override HotelBuchung CreateEntity(HotelBuchung entity)
        {
            ctx.HotelBuchungen.Add(entity);
            ctx.SaveChanges();
            return entity;
        }

        protected override HotelBuchung GetEntityByKey(int key)
        {
            return ctx.HotelBuchungen.Find(key);
        }

        protected override int GetKey(HotelBuchung entity)
        {
            return entity.HotelBuchungId;
        }




        protected override HotelBuchung PatchEntity(int key, Delta<HotelBuchung> patch)
        {
            var hbInDb = ctx.HotelBuchungen.Find(key);
            patch.Patch(hbInDb);
            ctx.SaveChanges();
            return hbInDb;
        }

        protected override HotelBuchung UpdateEntity(int key, HotelBuchung update)
        {
            update.HotelBuchungId = key;
            ctx.HotelBuchungen.Attach(update);
            ctx.Entry(update).State = System.Data.EntityState.Modified;
            ctx.SaveChanges();

            return update;
        }

        public override void Delete(int key)
        {
            var hb = ctx.HotelBuchungen.Find(key);
            ctx.Entry(hb).State = System.Data.EntityState.Deleted;
            ctx.SaveChanges();

        }
        /*
        [Queryable]
        public IQueryable<HotelBuchung> Get()
        {
            return ctx.HotelBuchungen.AsQueryable();
        }


        public HotelBuchung Get(int key)
        {
            return ctx.HotelBuchungen.Find(key);
        }


        public HttpResponseMessage Post(HotelBuchung hb)
        {
            ctx.HotelBuchungen.Add(hb);
            ctx.SaveChanges();

            var response = Request.CreateResponse(HttpStatusCode.Created, hb);
            

            return response;

        }

        public void Put(int key, HotelBuchung hb)
        {
            hb.HotelBuchungId = key;
            ctx.HotelBuchungen.Attach(hb);
            ctx.Entry(hb).State = System.Data.EntityState.Modified;
            ctx.SaveChanges();
        }

        public void Patch(int key, Delta<HotelBuchung> h)
        {
            var hbInDb = ctx.HotelBuchungen.Find(key);
            h.Patch(hbInDb);
            ctx.SaveChanges();
        }

        public HttpResponseMessage Delete(int key)
        {
            var hb = ctx.HotelBuchungen.Find(key);
            ctx.Entry(hb).State = System.Data.EntityState.Deleted;
            ctx.SaveChanges();

            return new HttpResponseMessage(HttpStatusCode.Accepted);
        }
*/

    }
}
