﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Web;

namespace ODataSample.Models
{

    public class HotelDbContext : DbContext
    {
        public HotelDbContext()
            : base("ODataHotelSampleDb")
        {
            Database.SetInitializer(new CreateDatabaseIfNotExists<HotelDbContext>());
            
        }

        public DbSet<Region> Regionen { get; set; }
        public DbSet<Hotel> Hotels { get; set; }
        public DbSet<HotelBuchung> HotelBuchungen { get; set; }
    }

    public class Region
    {
        public Region()
        {
            Hotels = new List<Hotel>();
        }

        public int RegionId { get; set; }
        public string Bezeichnung { get; set; }
        public ICollection<Hotel> Hotels { get; set; }
    }

    public class Hotel
    {
        public Hotel()
        {
            HotelBuchungen = new List<HotelBuchung>();
        }
        
        public int HotelId { get; set; }
        public string Bezeichnung { get; set; }
        public int Sterne { get; set; }
        public ICollection<HotelBuchung> HotelBuchungen { get; set; }

        public Region Region { get; set; }
    }

    public class HotelBuchung
    {
        public int HotelBuchungId { get; set; }
        public string Vorname { get; set; }
        public string Nachname { get; set; }
        public DateTime Datum { get; set; }
        public int AnzahlTage { get; set; }

        //public int? HotelId { get; set; }
        //public virtual Hotel Hotel { get; set; }
    }
}