﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Threading.Tasks;
using System.Web;



namespace Client
{

    class Program
    {
        static void Main(string[] args)
        {
            // SecurityDemo();
            ClientCertDemo();

            Console.WriteLine("Fertig");
            Console.ReadLine();
        }

        private static async Task SecurityDemo()
        {
            Console.WriteLine("[Enter]: Starten");
            Console.ReadLine();

            var handler = new WebRequestHandler();
            
            handler.Credentials = new NetworkCredential("max", "geheim");
        
            var client = new HttpClient(handler);
            var response = await client.GetAsync("https://localhost:4443/api/secure");
            var result = response.Content.ReadAsStringAsync().Result;

            Console.WriteLine("Status: " + response.StatusCode);
            Console.WriteLine(result);
        }

        private static async Task ClientCertDemo()
        {
            Console.WriteLine("[Enter]: Starten");
            Console.ReadLine();

            var handler = new WebRequestHandler();

            // Client Certificate
            var cert = LoadCert();
            handler.ClientCertificates.Add(cert);

            var client = new HttpClient(handler);
            // var response = await client.GetAsync("https://localhost:4443/api/secure/123");
            var response = await client.GetAsync("https://localhost:443/SecureService/api/secure/123");
            

            
            var result = response.Content.ReadAsStringAsync().Result;

            Console.WriteLine("Status: " + response.StatusCode);
            Console.WriteLine(result);
        }

        private static X509Certificate2 LoadCert()
        {
            X509Store store = new X509Store("My", StoreLocation.LocalMachine);
            store.Open(OpenFlags.ReadOnly);
            var certs = store.Certificates.Find(X509FindType.FindByThumbprint, "060f28445427f91de6427b5370ffb19c2b5eaf96", validOnly: false);
            var cert = certs[0];
            store.Close();
            return cert;
        }
    }
}
