﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Principal;
using System.Text;
using System.Threading;
using System.Web;

namespace SecureService.Modules
{
    public class BasicHttpModule : IHttpModule
    {

        public void Init(HttpApplication context)
        {
            context.AuthenticateRequest += context_AuthenticateRequest;
            context.EndRequest += context_EndRequest;
        }

        void context_EndRequest(object sender, EventArgs e)
        {
            var context = HttpContext.Current;
            var response = context.Response;

            if (response.StatusCode == 401)
            {
                response.AddHeader("WWW-Authenticate", "Basic");
            }
        }


        void context_AuthenticateRequest(object sender, EventArgs e)
        {
            var context = HttpContext.Current;
            var request = context.Request;
            var response = context.Response;
            var aspNetUser = context.User;

            var header = request.Headers["Authorization"];

            if (string.IsNullOrEmpty(header) || !header.Trim().ToLower().StartsWith("basic"))
            {
                return;
            }

            header = header.Trim();
            header = header.Substring(5); // Basic wegschneiden ...
            header = header.Trim();
            header = DecodeBase64(header);

            var index = header.IndexOf(':');
            if (index == -1)
            {
                response.Headers["WWW-Authenticate"] = "Basic";
                response.StatusCode = 401;
                response.StatusDescription = "Unauthorized";
                response.End();
                return;
            }

            var user = header.Substring(0, index);
            var password = header.Substring(index + 1);

            if (!(user == "max" && password == "geheim"))
            {
                response.Headers["WWW-Authenticate"] = "Basic";
                response.StatusCode = 403;
                response.StatusDescription = "Forbidden";
                response.End();
                return;
            }

            var roles = new string[] { };
            var identity = new GenericIdentity(user);
            var principal = new GenericPrincipal(identity, roles);

            Thread.CurrentPrincipal = principal;
            HttpContext.Current.User = principal;
            

        }

        private static string DecodeBase64(string header)
        {
            header = Encoding.UTF8.GetString(Convert.FromBase64String(header));
            return header;
        }

        private static string RemovePrefix(string str, string prefix)
        {
            if (str.StartsWith(prefix))
            {
                str = str.Substring(prefix.Length, str.Length - prefix.Length);
            }
            return str;
        }



        public void Dispose()
        {
        }

    }
}