﻿using System;
using System.Collections.Generic;
using System.IdentityModel.Selectors;  // !
using System.Linq;
using System.Security;
using System.Security.Cryptography.X509Certificates;
using System.Security.Principal;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Web;

namespace SelfHost
{
    class CustomCertValidator : X509CertificateValidator
    {

        public override void Validate(X509Certificate2 certificate)
        {
            if (certificate.Thumbprint != "060F28445427F91DE6427B5370FFB19C2B5EAF96")
            {
                throw new SecurityException("Benutzer ist nicht registriert!");
            }
            certificate.Verify();
            
            SetUpPrincipal(certificate);

        }

        private string LookUpUserName(X509Certificate2 certificate)
        {
            var userName = certificate.SubjectName.Name + "," + certificate.Thumbprint;
            return userName;
        }

        private void SetUpPrincipal(X509Certificate2 certificate)
        {
            var userName = LookUpUserName(certificate);

            var roles = new string[] { }; // In dieser Demo gibt es keine Rollen
            var identity = new GenericIdentity(userName);
            var principal = new GenericPrincipal(identity, roles);

            Thread.CurrentPrincipal = principal;
            if (HttpContext.Current != null) HttpContext.Current.User = principal;
        }
    }
}
