﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Security.Principal;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace SelfHost.Handler
{
    // Damit das mit IIS funktioniert, muss er anonyme Auth zulassen ...
    class HttpBasicHandler: DelegatingHandler
    {
        protected override Task<HttpResponseMessage> SendAsync(HttpRequestMessage request, System.Threading.CancellationToken cancellationToken)
        {
            HttpResponseMessage response;
            var auth = request.Headers.Authorization;


            if (auth == null || auth.Scheme.ToUpper() != "BASIC")
            {
                var resp = base.SendAsync(request, cancellationToken).Result;
                AddWwwAuthenticationIfUnauthorized(resp);
                return Task.FromResult(resp);
            }

            var parameter = DecodeBase64(auth.Parameter);

            var index = parameter.IndexOf(':');
            if (index == -1)
            {
                response = new HttpResponseMessage();
                response.Headers.WwwAuthenticate.Add(new AuthenticationHeaderValue("BASIC"));
                response.StatusCode = System.Net.HttpStatusCode.Unauthorized;
                return Task.FromResult(response);
            }

            var user = parameter.Substring(0, index);
            var password = parameter.Substring(index + 1);

            if (!(user == "max" && password == "geheim"))
            {
                response = new HttpResponseMessage();
                response.Headers.WwwAuthenticate.Add(new AuthenticationHeaderValue("BASIC"));
                response.StatusCode = System.Net.HttpStatusCode.Forbidden;
                return Task.FromResult(response);
            }
            
            var roles = new string[] { };
            var identity = new GenericIdentity(user);
            var principal = new GenericPrincipal(identity, roles);

            Thread.CurrentPrincipal = principal;

            return base.SendAsync(request, cancellationToken);

        }

        private static string DecodeBase64(string parameter)
        {
            parameter = Encoding.UTF8.GetString(Convert.FromBase64String(parameter));
            return parameter;
        }

        private static void AddWwwAuthenticationIfUnauthorized(HttpResponseMessage resp)
        {
            if (resp.StatusCode == System.Net.HttpStatusCode.Unauthorized)
            {
                resp.Headers.WwwAuthenticate.Add(new AuthenticationHeaderValue("BASIC"));
            }
        }
    }
}
