﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;  // !
using System.Text;
using System.Threading.Tasks;
using System.Web.Http;  // !
using System.Web.Http.SelfHost; // !
using SecureService.Controllers;
using SelfHost.Handler;

namespace SelfHost
{
    class Program
    {
        static void Main(string[] args)
        {
            var config = new HttpSelfHostConfiguration("https://localhost:4443");
            Type bc = typeof(SecureController);

            

            config.Routes.MapHttpRoute(
                "API Default", "api/{controller}/{id}",
                new { id = RouteParameter.Optional });
            

            
            // BASIC mit UserNamePasswordValidator
            // BASIC funktioniert mit Windows und Custom; DIGEST nur mit Custom
            // config.ClientCredentialType = HttpClientCredentialType.Basic;
            // config.UserNamePasswordValidator = new CustomUserNamePasswordValidator();

            // Client-Zertifikat
            //config.X509CertificateValidator = new CustomCertValidator();
            config.ClientCredentialType = HttpClientCredentialType.Certificate;
            

            // BASIC mit Handler
            // config.MessageHandlers.Add(new HttpBasicHandler());
            // config.MessageHandlers.Add(new HttpBasicHandlerWithSessionCookie());
            


            using (var host = new HttpSelfHostServer(config))
            {
                host.OpenAsync().Wait();
                Console.WriteLine("Host wurde gestartet ...");
                Console.ReadLine();
            }
        }
    }
}
