﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Security.Principal;
using System.Text;
using System.Web;
using System.Web.Mvc;
using ExtendingMVC.ActionResultImpl;
using ExtendingMVC.ActionSelector;
using ExtendingMVC.ModelBinding;
using ExtendingMVC.Models;

namespace ExtendingMVC.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult RazorHelper()
        {
            return View();
        }

        public ActionResult Index()
        {
            Session["info"] = "Hallo Welt";
            ViewBag.Message = "Modify this template to kick-start your ASP.NET MVC application.";

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }

        public ActionResult DoStuff(string msg, IPrincipal p, string userName)
        {
            return Content("OK");
        }

        public ActionResult ProcessPerson([ModelBinder(typeof(SimpleXmlModelBinder))] PersonModel person) {
            return Content("OK");
        }

        public ActionResult SessionSample(string info)
        {
            return Content(info);
        }

        public ActionResult ProcessPerson2(PersonModel person)
        {
            return CreateModelStateTextContent();
        }

        private ActionResult CreateModelStateTextContent()
        {
            var info = new StringBuilder();
            foreach (var entry in this.ModelState)
            {
                info.Append(entry.Key + "\n");
                if (entry.Value.Errors.Count == 0)
                {
                    info.Append("  Keine Validierungsfehler!\n");
                }
                foreach (var error in entry.Value.Errors)
                {
                    info.Append("  - " + error.ErrorMessage + "\n");
                }

            }

            return Content(info.ToString(), "text/plain");
        }

        public ActionResult ProcessUrl(Uri url)
        {
            return Content("OK");
        }

       

        public ActionResult ProcessAddress(Address addr)
        {
            return CreateModelStateTextContent();
        }

        public ActionResult DisplayAddress(Address addr)
        {
            return View(addr);
        }

        public ActionResult EditPerson(PersonModel p)
        {
            return View(p);
        }

        public ActionResult Debug(PersonModel p)
        {
            return View("__DEBUG__", p);
        }

        public ActionResult MenuDemo()
        {
            return View();
        }

        [HttpGet]
        public ActionResult MultiSubmitButtonDemo()
        {
            return View();
        }

        public ActionResult Data()
        {
            return Content("Standard-Data");
        }

        [MobileOnly]
        public ActionResult Data(int width, int height)
        {
            return Content("Mobile-Data");
        }


        [SubmitButtonActionNameSelectorAttribute(
            ActionName = "MultiSubmitButtonDemo", ButtonName = "btnDetail")]
        public ActionResult Detail()
        {
            return Content("Detail");
        }

        [SubmitButtonActionNameSelectorAttribute(
            ActionName = "MultiSubmitButtonDemo", ButtonName = "btnDetail")]
        [MobileOnly]
        public ActionResult DetailMobile()
        {
            return Content("DetailMobile");
        }

        
        [SubmitButtonActionNameSelectorAttribute(
            ActionName = "MultiSubmitButtonDemo", ButtonName = "btnCopy")]
        public ActionResult Copy()
        {
            return Content("Copy");
        }

        [SubmitButtonActionNameSelectorAttribute(
            ActionName = "MultiSubmitButtonDemo", ButtonName = "btnSave")]
        public ActionResult Save()
        {
            return Content("Save");
        }

        [SubmitButtonActionNameSelectorAttribute(
            ActionName = "MultiSubmitButtonDemo", ButtonName = "btnDelete")]
        public ActionResult Delete()
        {
            return Content("Delete");
        }

        public ActionResult Helper()
        {
            var p = new ProductNamesModel();
            p.ProductNames = new string[] { "ene", "mene", "muh" };
            
            return View(p);
        }

        public ActionResult Xml()
        {
            var p = new PersonModel();
            
            p.Id = 42;
            p.Vorname = "Max";
            p.Nachname = "Muster";
            p.Adresse = new Address();
            p.Adresse.Strasse = "Zuhause 8/15";
            p.Adresse.Plz = "4711";
            p.Adresse.Land = "Ambossanien";
            p.FriendsIds = new int[] { 1, 2, 3 };

            return new XmlActionResult(p);
        }

        public ActionResult ExtendedBaseClassSample()
        {
            return View();
        }

        public ActionResult UserWithPassword()
        {
            return View();
        }

        [HttpPost]
        public ActionResult UserWithPassword(User user)
        {
            return View(user);
        }
    }
}
