﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ExtendingMVC
{
    public class MobileOnlyAttribute: ActionMethodSelectorAttribute
    {

        public override bool IsValidForRequest(ControllerContext controllerContext, System.Reflection.MethodInfo methodInfo)
        {
            var request = controllerContext.HttpContext.Request;
            var userAgent = request.Headers["User-Agent"];

            if (string.IsNullOrEmpty(userAgent)) return false;
            if (userAgent.ToLower().Contains("mobile")) return true;
            return false;
        }
    }
}