﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ExtendingMVC.ActionSelector
{
    public class SubmitButtonActionNameSelectorAttribute : ActionNameSelectorAttribute
    {
        public String ButtonName { get; set; }
        public String ActionName { get; set; }

        public override bool IsValidName(ControllerContext controllerContext, string actionName, System.Reflection.MethodInfo methodInfo)
        {
            var request = controllerContext.HttpContext.Request;
            var nameMatches = (actionName.ToLower() == ActionName.ToLower());
            var buttonWasPushed = (!string.IsNullOrEmpty(request.Form[ButtonName]));

            if (nameMatches && buttonWasPushed) return true;
            return false;
        }
    }
}