﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.Optimization;
using System.Web.Routing;
using ExtendingMVC.Metadata;
using ExtendingMVC.ModelBinding;
using ExtendingMVC.Models;
using ExtendingMVC.Validation;
using ExtendingMVC.ViewEngine;

namespace ExtendingMVC
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        protected void Application_Start()
        {
            AreaRegistration.RegisterAllAreas();

            ModelBinders.Binders.DefaultBinder = new SimpleCustomModelBinder();
            ModelBinders.Binders.Add(typeof(int[]), new IntArrayModelBinder());
            ModelBinders.Binders.Add(typeof(Address), new AddressModelBinder());

            ValueProviderFactories.Factories.Add(new DemoXmlValueProviderFactory());
            ValueProviderFactories.Factories.Add(new SessionValueProviderFactory());

            ViewEngines.Engines.Add(new ViewEngineDemo());
            ViewEngines.Engines.Add(new CustomRazorEngine());

            //ModelMetadataProviders.Current = new CustomMetadataProvider();
            ModelMetadataProviders.Current = new CustomDataAnnotationsModelMetadataProvider();

            ModelValidatorProviders.Providers.Add(new CustomModelValidatorProvider());

            FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
            RouteConfig.RegisterRoutes(RouteTable.Routes);
            BundleConfig.RegisterBundles(BundleTable.Bundles);
        }
    }
}