﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ExtendingMVC.Metadata
{
    public class CustomDataAnnotationsModelMetadataProvider : DataAnnotationsModelMetadataProvider
    {
        protected override ModelMetadata CreateMetadata(IEnumerable<Attribute> attributes, Type containerType, Func<object> modelAccessor, Type modelType, string propertyName)
        {
            var metadata = base.CreateMetadata(attributes, containerType, modelAccessor, modelType, propertyName);

            var attr = attributes.OfType<ToolTipAttribute>().FirstOrDefault();
            if (attr != null)
            {
                metadata.AdditionalValues.Add("tooltiptext", attr.ToolTipText);
            }
            
            return metadata;
        }
    }
}