﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Xml;
using System.Xml.XPath;

namespace ExtendingMVC.ModelBinding
{

    public class SessionValueProviderFactory : System.Web.Mvc.ValueProviderFactory
    {
        public override IValueProvider GetValueProvider(ControllerContext controllerContext)
        {

            return new SessionValueProvider(controllerContext.HttpContext.Session);
        }
    }

    public class SessionValueProvider: IValueProvider
    {
        private HttpRequestBase request;
        private HttpSessionStateBase session;

     
        public SessionValueProvider(HttpSessionStateBase httpSessionStateBase)
        {
            this.session = httpSessionStateBase;
        }
       
        public bool ContainsPrefix(string prefix)
        {
            var found = (session[prefix] != null);
            return found;
        }

        public ValueProviderResult GetValue(string key)
        {
            var value = session[key];
            return new ValueProviderResult(value, null, null);
        }
    }
}