﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ExtendingMVC.Models;

namespace ExtendingMVC.Validation
{
    public class CustomModelValidatorProvider : ModelValidatorProvider
    {
        public override IEnumerable<ModelValidator> GetValidators(ModelMetadata metadata, ControllerContext context)
        {
            var validators = new List<ModelValidator>();

            if (metadata.ContainerType == typeof(PersonModel) && metadata.PropertyName == "Vorname")
            {
                validators.Add(new CustomStringLengthValidator(metadata, context, 2, 3));
            }

            return validators;
        }
    }
}