﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Web;
using System.Web.Mvc;
using System.Web.UI.WebControls.Expressions;

//namespace System.Web.Mvc.Html
namespace System.itvisions.helper
{
    public static class ListHelper
    {

        public static IHtmlString UnorderedList<Model, Property>(this HtmlHelper<Model> html, Expression<Func<Model, Property>> expr)
        {
            var metadata = ModelMetadata.FromLambdaExpression(expr, html.ViewData);
            if (metadata == null || metadata.Model == null) return new HtmlString("");
            
            var entries = metadata.Model as IEnumerable<object>;
            if (entries == null) return new HtmlString("");

            var buffer = new StringBuilder();

            buffer.Append("<ul>\n");

            foreach (var obj in entries)
            {
                buffer.AppendFormat("   <li>{0}</li>\n", obj.ToString());
            } 
            buffer.Append("</ul>\n");
            return new HtmlString(buffer.ToString());
        }
    }
}