﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Html;

namespace System.Web.Mvc.Html
{
    public static class ToolTipHelper
    {
        public static IHtmlString LabelWithToolTipFor<Model, Property>(this HtmlHelper<Model> html, Expression<Func<Model, Property>> expr)
        {
            var label = LabelExtensions.LabelFor(html, expr);
            var str = label.ToHtmlString();

            var metadata = ModelMetadata.FromLambdaExpression(expr, html.ViewData);
            if (metadata.AdditionalValues.ContainsKey("tooltiptext"))
            {
                str = @"<acronym title=""" + metadata.AdditionalValues["tooltiptext"] + @""">" + str + "</acronym>";
                return new HtmlString(str);
            }
            return label;

        }
    }
}