﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace ExtendingMVC.ViewEngine
{
    public class CustomRazorEngine: RazorViewEngine
    {
        public CustomRazorEngine(): base()
        {
            // this.AreaMasterLocationFormats
            // this.AreaPartialViewLocationFormats
            // this.AreaViewLocationFormats
            // this.MasterLocationFormats
            // this.PartialViewLocationFormats
            // this.ViewLocationFormats

            var locations = this.PartialViewLocationFormats.ToList();

            locations.Add("~/Views/Navigation/{0}.cshtml");
            locations.Add("~/Views/Navigation/{0}.vbhtml");

            this.PartialViewLocationFormats = locations.ToArray();
        }

        public override ViewEngineResult FindPartialView(ControllerContext controllerContext, string partialViewName, bool useCache)
        {
            return base.FindPartialView(controllerContext, partialViewName, useCache);
        }

        public override ViewEngineResult FindView(ControllerContext controllerContext, string viewName, string masterName, bool useCache)
        {
            var user = controllerContext.HttpContext.User;
            if (viewName == "Index" && !user.Identity.IsAuthenticated)
            {
                var viewPath = "~/Views/Anonymous/Index.cshtml";
                var masterPath = masterName;

                if (this.VirtualPathProvider.FileExists(viewPath))
                {
                    var view = CreateView(controllerContext, viewPath, masterPath);
                    return new ViewEngineResult(view, this);
                }
            }
            return base.FindView(controllerContext, viewName, masterName, useCache);
            
        }
        
        
    }
}