﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Http;
using System.Web.Http.Controllers;
using System.Web.Http.Dispatcher;
using System.Web.Http.Filters;
using System.Web.Http.Metadata;
using System.Web.Http.Validation;
using ExtWebApi.AssemblyResolver;
using ExtWebApi.DependencyResolver;
using ExtWebApi.Filter;
using ExtWebApi.Metadata;
using ExtWebApi.ModelBinder;
using ExtWebApi.Models;
using ExtWebApi.Selection;
using ExtWebApi.Validation;

namespace ExtWebApi
{
    public static class WebApiConfig
    {
        public static void Register(HttpConfiguration config)
        {

            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );

            var assemblyResolver = new CustomAssembliesResolver();
            config.Services.Replace(typeof(IAssembliesResolver), assemblyResolver);

            config.DependencyResolver = new CustomDependencyResolver();

            config.ParameterBindingRules.Insert(0, PrincipalParameterBindingRule.GetRule);
            config.ParameterBindingRules.Add(HeaderParameterBindingRule.GetRule);
            //config.ParameterBindingRules.Insert(0, AdresseParameterBindingRule.GetRule);
            // config.ParameterBindingRules.Add(typeof(Adresse), AdresseParameterBindingRule.GetRule);

            

            config.Filters.Add(new SampleActionFilterAttribute());
            config.Services.Add(typeof(IFilterProvider), new CustomFilterProvider());

            config.Services.Replace(typeof(IHttpActionSelector), new CustomActionSelector());
            config.Services.Replace(typeof(IHttpControllerSelector), new CustomHttpControllerSelector(config));
            

            config.Services.Add(typeof(ModelValidatorProvider), new CustomModelValidatorProvider());
            config.Services.Replace(typeof(ModelMetadataProvider), new CustomModelMetadataProvider());
            

        }
    }
}
