﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Web.Http;
using System.Web.Http.ModelBinding;
using ExtWebApi.ModelBinder;
using ExtWebApi.Models;

namespace ExtWebApi.Controllers
{
    public class CustomModelBinderSampleController : ApiController
    {
        public Adresse Get([AdresseParameterBinding]Adresse a)
        {
            if (!this.ModelState.IsValid)
            {
                var response = new HttpResponseMessage(HttpStatusCode.BadRequest);
                var errorMessage = CreateErrorMessage();
                response.Content = new StringContent(errorMessage);
                throw new HttpResponseException(response);
            }

            return a;
        }

        private string CreateErrorMessage()
        {
            var sb = new StringBuilder();
            foreach (var p in this.ModelState)
            {
                if (p.Value.Errors.Count > 0)
                {
                    sb.Append(p.Key + ": ");
                    foreach (var error in p.Value.Errors)
                    {
                        sb.Append(error.ErrorMessage + ", ");
                    }
                    sb.Length = sb.Length - 2;
                    sb.Append("\n");
                }
            }
            var errorMessage = sb.ToString();
            return errorMessage;
        }
    }
}
