﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Text;
using System.Web.Http;
using ExtWebApi.Models;

namespace ExtWebApi.Controllers
{
    public class CustomValidationSampleController : ApiController
    {
        public Adresse Post(Adresse a)
        {
            ThrowExceptionIfModelErrors();
            return a;
        }

        private void ThrowExceptionIfModelErrors()
        {
            if (!this.ModelState.IsValid)
            {
                var response = new HttpResponseMessage(HttpStatusCode.BadRequest);
                response.Content = new StringContent(CreateErrorMessage());
                throw new HttpResponseException(response);
            }
        }

        private string CreateErrorMessage()
        {
            var sb = new StringBuilder();
            foreach (var p in this.ModelState)
            {
                if (p.Value.Errors.Count > 0)
                {
                    sb.Append(p.Key + ": ");
                    foreach (var error in p.Value.Errors)
                    {
                        sb.Append(error.ErrorMessage + ", ");
                    }
                    sb.Length = sb.Length - 2;
                    sb.Append("\n");
                }
            }
            var errorMessage = sb.ToString();
            return errorMessage;
        }
    }
}
