﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using ExtWebApi.Filter;

namespace ExtWebApi.Controllers
{
    [SampleAuthorizationFilter]
    // [SampleActionFilter] // Kommt trotzdem zur Ausführung, weil er auch als globaler Filter definiert ist
    public class FilterSampleController : ApiController
    {
        private static string value = "42";

        public string Get()
        {
            return value;
        }

        /*
         * [SampleExceptionFilter] // Kommt trotzdem zur Ausführung, weil er über CustomFilterProvider geliefert wird
         * 
         * Aufruf zum Provozieren einer Exception:
         * ----------------------------------------------------------------
         * POST http://localhost/ExtWebApi/api/FilterSample?newValue=
         * Content-Length: 0
         * Host: localhost
         * 
         */
        public void Post([FromUri] string newValue) {

            if (string.IsNullOrEmpty(newValue)) throw new ArgumentException("Darf nicht null oder leer sein!");
            value = newValue;
        }
        
        public void Delete()
        {
            value = "";
        }
    }
}
