﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http.Metadata;
using System.Web.Http.Metadata.Providers;
using ExtWebApi.Models;

namespace ExtWebApi.Metadata
{
    public class CustomModelMetadataProvider : DataAnnotationsModelMetadataProvider
    {
        protected override CachedDataAnnotationsModelMetadata CreateMetadataFromPrototype(CachedDataAnnotationsModelMetadata prototype, Func<object> modelAccessor)
        {
            var result = base.CreateMetadataFromPrototype(prototype, modelAccessor);
            BuildMetadata(result);
            return result;
        }

        protected override CachedDataAnnotationsModelMetadata CreateMetadataPrototype(IEnumerable<Attribute> attributes, Type containerType, Type modelType, string propertyName)
        {
            var result = base.CreateMetadataPrototype(attributes, containerType, modelType, propertyName);
            BuildMetadata(result);
            return result;
        }

        private void BuildMetadata(ModelMetadata metadata)
        {
            if (metadata.ContainerType == typeof(Adresse) && metadata.PropertyName == "Strasse")
            {
                // 1. Informationen zu metadata "ermitteln"
                var displayName = "*" + metadata.PropertyName + "*";
                var minLength = 5;

                

                // 2. Ermittelte Informationen setzen
                metadata.Description = "*" + metadata.PropertyName + "*";
                metadata.AdditionalValues["minLengthWithoutNumber"] = minLength;
            }
        }
    }
}