﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace ExtWebApi.Metadata
{
    public class Hotel
    {
        public int Id { get; set; }

        [Required(ErrorMessage = "{0} ist ein Pflichtfeld")]
        public string Bezeichnung { get; set; }

        [Range(1, 7, ErrorMessage = "{0} muss sich zwischen {1} und {2} befinden")]
        public int Sterne { get; set; }

        [EmailAddress(ErrorMessage="{0} muss eine gültige EMail-Adresse sein")]
        public string EMail { get; set; }
    }


    // -- generierte Datei --

    //public partial class Hotel
    //{
    //    public int Id { get; set; }
    //    public string Bezeichnung { get; set; }
    //    public int Sterne { get; set; }
    //}

    //// -- separate Datei --

    //[MetadataType(typeof(HotelMetadata))]
    //public partial class Hotel
    //{
    //}


    public class HotelMetadata
    {
        [Required(ErrorMessage="{0} ist ein Pflichtfeld")]
        [Display(Name="Hotel-Bezeichnung")]
        public object Bezeichnung;
        
        [Required(ErrorMessage = "{0} ist ein Pflichtfeld")]
        [Range(1, 7, ErrorMessage="{0} muss sich zwischen {1} und {2} befinden")]
        public object Sterne;
    }
}