﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http.Formatting;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http.Controllers;
using System.Web.Http.Validation;
using ExtWebApi.Models;

namespace ExtWebApi.ModelBinder
{


    public class AdresseParameterBinding : HttpParameterBinding
    {
        public AdresseParameterBinding(HttpParameterDescriptor desc)
            : base(desc)
        {
        }

        public override System.Threading.Tasks.Task ExecuteBindingAsync(System.Web.Http.Metadata.ModelMetadataProvider metadataProvider, HttpActionContext actionContext, System.Threading.CancellationToken cancellationToken)
        {
            var param = HttpContext.Current.Request[Descriptor.ParameterName].ToString();
            //var param = actionContext.Request.Properties[Descriptor.ParameterName].ToString();
            var parts = param.Split(',');
            var adr = new Adresse();
            adr.Strasse = parts[0];
            adr.Plz = parts[1];

            SetValue(actionContext, adr);

            Validate(Descriptor, metadataProvider, actionContext, adr, "Strasse", () => adr.Strasse);
            Validate(Descriptor, metadataProvider, actionContext, adr, "Plz", () => adr.Plz);



            var tcs = new TaskCompletionSource<AsyncVoid>();
            tcs.SetResult(default(AsyncVoid));
            return tcs.Task;
        }

        private void Validate(HttpParameterDescriptor Descriptor, System.Web.Http.Metadata.ModelMetadataProvider metadataProvider, HttpActionContext actionContext, Adresse adr, string propName, Func<object> accessor)
        {

            var metaData = metadataProvider.GetMetadataForProperty(accessor, typeof(Adresse), propName);

            var validators = actionContext.GetValidators(metaData);

            foreach (var validator in validators)
            {
                var errors = validator.Validate(metaData, metaData.Model);
                foreach (var error in errors)
                {
                    var fullPropName = Descriptor.ParameterName + "." + propName;
                    actionContext.ModelState.AddModelError(fullPropName, error.Message);
                }

            }

        }


    }
}