﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Web;
using System.Web.Http.Controllers;

namespace ExtWebApi.ModelBinder
{
    public class HeaderParameterBinding : HttpParameterBinding
    {
        public HeaderParameterBinding(HttpParameterDescriptor desc)
            : base(desc)
        {
        }

        public override System.Threading.Tasks.Task ExecuteBindingAsync(System.Web.Http.Metadata.ModelMetadataProvider metadataProvider, HttpActionContext actionContext, System.Threading.CancellationToken cancellationToken)
        {
            var headerName = Descriptor.ParameterName.Replace("_", "-");

            // actionContext.ModelState.AddModelError(..., ...)

            if (actionContext.Request.Headers.Contains(headerName))
            {
                SetValue(actionContext, actionContext.Request.Headers.GetValues(headerName).FirstOrDefault());
            }

            var tcs = new TaskCompletionSource<object>();
            tcs.SetResult(null);
            return tcs.Task;

        }
    }
}