﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Principal;
using System.Web;
using System.Web.Http.Controllers;

namespace ExtWebApi.ModelBinder
{
    public class PrincipalParameterBindingRule
    {
        // Zum Testen auth in web.config aktivieren, z. B. mit <authentication mode="Windows" />
        public static HttpParameterBinding GetRule(HttpParameterDescriptor descriptor)
        {
            if (descriptor.ParameterName == "userName" && descriptor.ParameterType == typeof(string))
            {
                return new UserNameParameterBinding(descriptor);
            }
            else if (descriptor.ParameterType == typeof(IPrincipal))
            {
                return new PrincipalParameterBinding(descriptor);
            }

            return null;
        }
    }
}