﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web;
using System.Web.Http.Controllers;

namespace ExtWebApi
{
    public class CustomActionSelector : ApiControllerActionSelector
    {
        public override HttpActionDescriptor SelectAction(HttpControllerContext controllerContext)
        {
            const string X_HTTP_METHOD_OVERRIDE = "X-HTTP-Method-Override";
            var request = controllerContext.Request;

            if (request.Headers.Contains(X_HTTP_METHOD_OVERRIDE))
            {
                request.Method = new HttpMethod(request.Headers.GetValues(X_HTTP_METHOD_OVERRIDE).First());
            }
            
            return base.SelectAction(controllerContext);
        }
    }
}