﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Http;
using System.Web.Http.Controllers;
using System.Web.Http.Dispatcher;

namespace ExtWebApi.Selection
{
    public class CustomHttpControllerSelector : DefaultHttpControllerSelector
    {
        HttpConfiguration configuration;
        IDictionary<string, HttpControllerDescriptor> cache;

        public CustomHttpControllerSelector(HttpConfiguration configuration): base(configuration) {
            this.configuration = configuration;
            
            cache = new Dictionary<string, HttpControllerDescriptor>();
            cache = GetControllerMapping();
        }

   
        
        public override System.Web.Http.Controllers.HttpControllerDescriptor SelectController(System.Net.Http.HttpRequestMessage request)
        {
            if (request.Headers.Contains("X-Debug") && request.Headers.First(h => h.Key == "X-Debug").Value.First() == "Mock")
            {
                var controllerName = base.GetControllerName(request) + "Mock";
                controllerName = controllerName.ToLower();
                if (!cache.ContainsKey(controllerName)) throw new HttpResponseException(HttpStatusCode.BadRequest);
                var controllerDescriptor = cache[controllerName];
                return controllerDescriptor;

            }
            return base.SelectController(request);
        }
    }
}