﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DI.Data;
using DI.Models;

namespace DI.Controllers
{
    public class HomeController : Controller
    {
        private ICustomerDAO dao;

        private string Id = Guid.NewGuid().ToString();

        public HomeController(ICustomerDAO dao)
        {
            this.dao = dao;
            
        }

        public ActionResult Index()
        {
            var result = dao.FindCustomersBy(null, null, null);

            ViewBag.Message = "Found Customers: " + result.Count + ", DAO-ID: " + ((CustomerDAO)dao).Id + ", Ctr-Id: " + Id;

            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}
