﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.Practices.Unity;

namespace DI
{
    public class UnityDependencyResolver: IDependencyResolver
    {
        private IUnityContainer container;

        public UnityDependencyResolver(IUnityContainer container)
        {
            this.container = container;
        }

        public object GetService(Type serviceType)
        {
            if (serviceType.IsClass && !serviceType.IsAbstract)
            {
                var ctr = container.Resolve(serviceType);
                return ctr;
            }


            if (!container.IsRegistered(serviceType)) return null;
            var obj = container.Resolve(serviceType);
            return obj;
        }

        public IEnumerable<object> GetServices(Type serviceType)
        {
            if (!container.IsRegistered(serviceType)) return new List<object>();
            var objs = container.ResolveAll(serviceType);
            return objs;

        }
    }
}